{
   Ŀ
    Form Statistic Report for Mailserver Traffic       
    (c) 1993 by Valery Votintsev                       
    Tver, Russia   vot@infolink.tver.su                
         Usage:                                        
             Stat mm.yy                                
         where mm - month number (2 digits)            
               yy - year (last 2 digits)               
         for example: stat 05.96                       
             (create report for May 1996)              
   
}
Program STAT;
USES
   MAIL;

CONST
   MonthName:Array[1..12] of String[10]=
             ('','ࠫ','',    '५', '',   '',
              '',  '', '','','','');
   LocalListName='Mailserv.loc'; {Local Address List File}
   cDomens='Mailserv.dom';

VAR
   StartDate,
   EndDate:String;
   F,FLoc,FRem,FTot:TEXT;
   MailStatName,
   RemoteReportName,
   LocalReportName,
   TotalReportName:String;
   cFrom,
   cTo,
   cSize,
   cTime,
   cDate,
   Date,
   Month,
   Year,
   S:String;

   LCost,
   RCost,
   LocalALL,
   RemoteAll,
   RNDS,
   lNDS:Real;

   Size,
   LocalTotal,
   RemoteTotal,
   LocalNumber,
   RemoteNumber:LongInt;

   Local :Boolean;
{------------------------------------------------}
Function CheckLocal(address:String):Boolean;
{ Read User is Local }
Var
   F:TEXT;
   Loc:Boolean;
   S:String;
begin
   CheckLocal:=FALSE;

   fOpen(F,Exedir+'\'+LocalList,F_READ); { Open Local Domains List    }
   While not EOF(F) do begin
      Readln(F,S);
      S:=AllTrim(S);
      If S<>'' then begin
         If StUpCase(RIGHT(address,Length(S)))=StUpcase(S) then begin
            CheckLocal:=TRUE;
            Break;
         end;
      end;
   end;

   Close(F);
end;
{--------------------------------------------------------------}
begin

   Writeln('');
   Writeln('=============== STAT v.',Version,' ================');
   Writeln('======= CREATE MAILSERVER REPORT ===========');
   Writeln('(c) 1993 by Valery Votintsev, Info-Link ltd.');
   Writeln('============================================');

   If Length(ParamStr(1)) <> 5 then begin
      Writeln('Usage: stat mm.yy');
      Halt(1);
   end;

   GetConfig;        { Get Config Parameters                }
                     { & List of Enabled/Disabled Domains   }

   Size:=0;
   lCost:=0;
   LocalTotal:=0;
   lNDS:=0;
   LocalALL:=0;
   LocalNumber:=0;

   rCost:=0;
   RemoteTotal:=0;
   rNDS:=0;
   RemoteALL:=0;
   RemoteNumber:=0;

   Month:=Left (ParamStr(1),2);
   Year :=Right(ParamStr(1),2);

   StartDate:=Year+'.'+Month+'.01';
   EndDate  :=Year+'.'+Month+'.31';

   MailStatName:=UUPCPath+'\SPOOL\MAILSTAT.';
   RemoteReportName := ExeDir+'\REMOTE'+ParamStr(1);
   LocalReportName  := ExeDir+'\LOCAL' +ParamStr(1);
   TotalReportName  := ExeDir+'\TOTAL' +ParamStr(1);

   If not FOpen(F,MailStatName,F_READ) then
      Writeln('*** Can''t open '+MailStatName)
   else begin
      Writeln('Reading stats from '+MailStatName);

      If not FOpen(FLoc,LocalReportName,F_WRITE) then
         Writeln('*** Can''t open '+LocalReportName)
      else begin

         Writeln('Write Local Report to  '+LocalReportName);

         If not FOpen(FRem,RemoteReportName,F_WRITE) then
            Writeln('*** Can''t open '+RemoteReportName)
         else begin

            Writeln('Write Remote Report to '+RemoteReportName);

            If not FOpen(FTot,TotalReportName,F_WRITE) then
               Writeln('*** Can''t open '+TotalReportName)
            else begin

               Writeln('Write Total Report to  '+TotalReportName);

               Writeln(FLoc,'       ࠡ ࢥ');
               Writeln(FRem,'       ࠡ ࢥ');
               Writeln(FTot,'        ࠡ ࢥ');
               Writeln(     '        ࠡ ࢥ');

               Writeln(FLoc,'     ',ServerSendAddress);
               Writeln(FRem,'     ',ServerSendAddress);
               Writeln(FTot,'     ',ServerSendAddress);
               Writeln(     '     ',ServerSendAddress);

               Writeln(FLoc,'      ',MonthName[IntValue(Month)],' 19',Year,' .');
               Writeln(FRem,'      ',MonthName[IntValue(Month)],' 19',Year,' .');
               Writeln(FTot,'      ',MonthName[IntValue(Month)],' 19',Year,' .');
               Writeln(     '      ',MonthName[IntValue(Month)],' 19',Year,' .');

               Writeln(FLoc,'       :');
               Writeln(FRem,'       :');

               Writeln(FLoc,Replicate('-',73));
               Writeln(FRem,Replicate('-',73));
               Writeln(FTot,Replicate('-',73));
               Writeln(     Replicate('-',73));

               Writeln(FLoc,'   #                                        ',
                            '  ६    ');
               Writeln(FRem,'   #                                        ',
                            '  ६    ');
               Writeln(FTot,
               '        -   '' ()  業($)   㬬     ',
               '       ⮣');
               Writeln(
               '        -   '' ()  業($)   㬬     ',
               '       ⮣');

               Writeln(FLoc,Replicate('-',73));
               Writeln(FRem,Replicate('-',73));
               Writeln(FTot,Replicate('-',73));
               Writeln(     Replicate('-',73));

               While not EOF(F) do begin
                  Readln(F,S);
                  cFrom:=NextWord(S,WhiteSpace);
                  If cFrom = (SMachine+'!'+SName) then begin
                     address := NextWord(S,WhiteSpace);

                     { Check for ENABLED user }

                     If not AccessDisabled(address) then begin

                        { Check for LOCAL/REMOTE user }
                        Local:=CheckLocal(address);

                        cSize:=NextWord(S,WhiteSpace); { Size }
                        cTime:=NextWord(S,WhiteSpace); { Time }
                        cDate:=NextWord(S,WhiteSpace); { Date }

                        Date:=Copy(cDate,7,2)+Copy(cDate,3,4)+Copy(cDate,1,2);
                        Size:=IntValue(cSize);

                        If (Date >= StartDate) and
                           (Date <= EndDate) then begin

                           If Local then begin
                              Inc(LocalNumber);
                              Writeln(FLoc,LocalNumber:4,' ',PadR(address,40),
                                      Size:10,' ',cTime,' ',cDate);
                              Inc(LocalTotal,Size);
                           end else begin
                              Inc(RemoteNumber);
                              Writeln(FRem,RemoteNumber:4,' ',PadR(address,40),
                                      Size:10,' ',cTime,' ',cDate);
                              Inc(RemoteTotal,Size);
                           end;
                        end;
                     end;
                  end;
               end; {While not EOF}

               Close(F);

               Writeln(FLoc,Replicate('-',73));
               Writeln(FRem,Replicate('-',73));
               Writeln(FLoc,'     ⮣:',Spaces(32),LocalTotal:12,' .');
               Writeln(FRem,'     ⮣:',Spaces(32),RemoteTotal:12,' .');
               LocalTotal:=LocalTotal DIV 1024;
               RemoteTotal:=RemoteTotal DIV 1024;
               Writeln(FLoc,'         = ',Spaces(30),LocalTotal:12,'  .');
               Writeln(FRem,'         = ',Spaces(30),RemoteTotal:12,'  .');
               lCost:=LocalTotal*LocalCost;
               rCost:=RemoteTotal*RemoteCost;
               Writeln(FLoc,'     㬬                  ( ',
                       LocalTotal,' * ',LocalCost:6:3,+' ) ', lCOST:12:2, ' US $.');
               Writeln(FRem,'     㬬                  ( ',
                       RemoteTotal,' * ',RemoteCost:6:3,+' ) ', rCOST:12:2, ' US $.');
               lNDS:=lCOST * 0.2;
               rNDS:=rCOST * 0.2;
               Writeln(FLoc,'    20%:',Spaces(32),lNDS:12:2,' US $.');
               Writeln(FRem,'    20%:',Spaces(32),rNDS:12:2,' US $.');
               LocalAll:=lCOST+lNDS;
               RemoteAll:=rCOST+rNDS;
               Writeln(FLoc,'     ᥣ:',Spaces(32),LocalALL:12:2, ' US $.');
               Writeln(FRem,'     ᥣ:',Spaces(32),RemoteALL:12:2, ' US $.');
               Writeln(FLoc,Replicate('-',73));
               Writeln(FRem,Replicate('-',73));
               Writeln(FLoc,'');
               Writeln(FRem,'');
               Close(FLoc);
               Close(FRem);

               { Finish Total Report }
               Writeln(FTot,' ', LocalNumber:7,LocalTotal:9,
                       LocalCost:12:3,LCost:12:2,lNDS:9:2,LocalAll:12:2);
               Writeln(FTot,' ',RemoteNumber:7,RemoteTotal:9,
                       RemoteCost:12:3,rCost:12:2,rNDS:9:2,RemoteAll:12:2);
               Writeln(FTot,Replicate('-',73));
               Writeln(FTot,'    ᥣ:',Spaces(28),
                            (lCost+rCost):12:2,
                            (lNDS+rNDS):9:2,
                            (LocalALL+RemoteAll):12:2);
               Writeln(FTot,Replicate('-',73));
               Writeln(FTot,'');
               Close(FTot);


               Writeln(     ' ', LocalNumber:7,LocalTotal:9,
                       LocalCost:12:3,LCost:12:2,lNDS:9:2,LocalAll:12:2);
               Writeln(     ' ',RemoteNumber:7,RemoteTotal:9,
                       RemoteCost:12:3,rCost:12:2,rNDS:9:2,RemoteAll:12:2);
               Writeln(     Replicate('-',73));
               Writeln(     '    ᥣ:',Spaces(28),
                            (lCost+rCost):12:2,
                            (lNDS+rNDS):9:2,
                            (LocalALL+RemoteAll):12:2);
               Writeln(     Replicate('-',73));
               Writeln(     'Report Comleted.');

            end;
         end;
      end;
   end; {if}

end.



